////////////////////////////////////////////////////////////////////////
// epginfo.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.epginfo")

// <%pre>
#line 1 "epginfo.ecpp"


#include <stdext.h>
#include <exception.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <recman.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class epgTools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epgTools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    epgTools_type epgTools;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("epginfo");

static const char* rawData = "\000\000\000\134\000\000\000\316\000\000\000\327\000\000\000\333\000\000\000\340\000\000"
  "\000\345\000\000\000\346\000\000\001+\000\000\001/\000\000\0014\000\000\0015\000\000\001N\000\000\001R\000\000\001S"
  "\000\000\001W\000\000\001X\000\000\001\134\000\000\001]\000\000\001{\000\000\001|\000\000\001}\000\000\001\177\000"
  "\000\001\200\n<html>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <"
  "title>VDR-Live - </title>\n    \n    \n    \n  </head>\n  <body onload=\"adjustHeader()\" onresize=\"adjustHeader()\""
  ">\n    \n    \n    <div class=\"inhalt\">\n    \n    \n    \n    </div>\n  </body>\n</html>\n\n\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    epgTools(*this, "epgTools")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("epginfo " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
std::string delete_rec = qparam.get< std::string >("delete_rec");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
std::string async = qparam.get< std::string >("async");
std::string tab = qparam.get< std::string >("tab");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
  // </%args>

#line 24 "epginfo.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 27 "epginfo.ecpp"
  typedef EpgInfo    epgEvent_type;
  TNT_REQUEST_SHARED_VAR(EpgInfo   , epgEvent, ());   // <%request> EpgInfo    epgEvent
  _tnt_ignore_unused<epgEvent_type>(epgEvent);
#line 28 "epginfo.ecpp"
  typedef std::string epgImage_type;
  TNT_REQUEST_SHARED_VAR(std::string, epgImage, ());   // <%request> std::string epgImage
  _tnt_ignore_unused<epgImage_type>(epgImage);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 31 "epginfo.ecpp"

  reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }

  pageTitle = tr("Electronic program guide information");

  bool ajaxReq = !async.empty() && (parse_int<int>(async) != 0);

  bool aboutBox = false;
  if (epgid.compare(0, 4, "del_") == 0) {
    delete_rec = "to_confirm";
    epgid.erase(0, 4);
  }

  bool isEvent = false;
  bool isRecording = false;
  epgImage.clear();
// we use objects of these types during creation of this page, so keep the locks

  if (!delete_rec.empty()) {
      pageTitle = tr("Delete recordings");
  } else if (!epgid.empty()) {

    const std::string_view recording_s("recording_");
    const std::string_view event_s("event_");
    const std::string_view aboutbox("aboutBox");

    // check for recording:
    if (epgid.compare(0, recording_s.length(), recording_s) == 0) {
      isRecording = true;
      LOCK_RECORDINGS_READ;
      const cRecording *recording = RecordingsManager::GetByHash(epgid, Recordings);
      if (recording == 0) {
        throw HtmlError(tr("Couldn't find recording or no recordings available"));
      }
      epgEvent.CreateEpgInfo(epgid, recording);
      cTvMedia image;
      EpgEvents::PosterTvscraper(image, NULL, recording);
      epgImage = image.path;
    }
    // check for event:
    else if (epgid.compare(0, event_s.length(), event_s) == 0) {
      /* Need to lock here channels also, because CreateEpgInfo will lock
       * it also and this will result in a wrong lock order */
      epgEvent.CreateEpgInfo(epgid);
      isEvent = true;
      LOCK_SCHEDULES_READ;
      const cEvent* event = EpgEvents::GetEventByEpgId(epgid, Schedules);
      cTvMedia image;
      EpgEvents::PosterTvscraper(image, event, nullptr);
      epgImage = image.path;
    }
    // check for aboutbox:
    else if (epgid.compare(0, aboutbox.length(), aboutbox) == 0) {
      aboutBox = true;
    }
  }

  // <& pageelems.doc_type ...
  { 
#line 93 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 93 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 97 "epginfo.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n
#line 98 "epginfo.ecpp"

  if (!ajaxReq) {

  reply.out() << _tntChunks[2]; //     
  // <& pageelems.stylesheets ...
  { 
#line 101 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 101 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 102 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 102 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 103 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 103 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n
#line 104 "epginfo.ecpp"

  }

  reply.out() << _tntChunks[6]; //   </head>\n  <body onload="adjustHeader()" onresize="adjustHeader()">\n
#line 109 "epginfo.ecpp"

  if (!ajaxReq) {

  reply.out() << _tntChunks[7]; //     
  // <& pageelems.logo ...
  { 
#line 112 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 112 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[8]; // \n    
  // <& menu ...
  { 
#line 113 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 113 "epginfo.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[9]; // \n
#line 114 "epginfo.ecpp"

  }

  reply.out() << _tntChunks[10]; //     <div class="inhalt">\n
#line 118 "epginfo.ecpp"

  if (!epgEvent.Id().empty() && delete_rec.empty()) {
    uintptr_t i_epgEvent = (uintptr_t)&epgEvent;
    cToSvConcat start(epgEvent.StartTime("%a,"), ' ',
                      epgEvent.StartTime(tr("%b %d %y")), ' ',
                      epgEvent.StartTime(tr("%I:%M %p")) );
    if (epgEvent.isRecording() ) {
      start << " - " << epgEvent.EndTime(tr("%I:%M %p")) << ' ';
      AppendDuration(start, tr("(%d:%02d)"), epgEvent.Duration());
    }

    std::string tools_component;
    if (isRecording) {
      tools_component = epgEvent.Archived().empty() ? "recordings.rec_tools" : "recordings.archived_disc" ;
    }
    if (isEvent)
      tools_component = "epginfo.epgTools";


  reply.out() << _tntChunks[11]; //     
  // <& pageelems.epg_tt_box ...
  { 
#line 137 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "archived", (epgEvent.Archived()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "boxId", (epgEvent.Id()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "caption", (epgEvent.Caption()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "channel", (epgEvent.ChannelName()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "elapsed", (epgEvent.Elapsed()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "epgImage", (epgImage));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "filename", (epgEvent.FileName()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "flat", (flat));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "history_num_back", (history_num_back));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "iepgEvent", (i_epgEvent));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "long_descr", (epgEvent.LongDescr()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "short_descr", (epgEvent.ShortDescr()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "sort", (sort));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "time", (start));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "title", (epgEvent.Title()));
#line 137 "epginfo.ecpp"
    _tnt_cq6.add( "tools_comp", (tools_component));
#line 137 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tt_box"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[12]; // \n
#line 138 "epginfo.ecpp"

  }
  if (aboutBox) {

  reply.out() << _tntChunks[13]; //     
  // <& pageelems.about_tt_box ...
  { 
#line 142 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 142 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "about_tt_box"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[14]; // \n
#line 143 "epginfo.ecpp"

  }
  if (!delete_rec.empty() ) {

  reply.out() << _tntChunks[15]; //     
  // <& recordings.todel ...
  { 
#line 147 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 147 "epginfo.ecpp"
    _tnt_cq8.add( "confirmed", (delete_rec));
#line 147 "epginfo.ecpp"
    _tnt_cq8.add( "history_num_back", (history_num_back));
#line 147 "epginfo.ecpp"
    _tnt_cq8.add( "todel", (epgid));
#line 147 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "todel"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[16]; // \n
#line 148 "epginfo.ecpp"
 }

  reply.out() << _tntChunks[17]; //     </div>\n  </body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[18]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[19]; // \n
  reply.out() << _tntChunks[20]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epgTools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("epginfo::epgTools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
int detail = qparam.get< int >("detail");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 24 "epginfo.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 27 "epginfo.ecpp"
  typedef EpgInfo    epgEvent_type;
  TNT_REQUEST_SHARED_VAR(EpgInfo   , epgEvent, ());   // <%request> EpgInfo    epgEvent
  _tnt_ignore_unused<epgEvent_type>(epgEvent);
#line 28 "epginfo.ecpp"
  typedef std::string epgImage_type;
  TNT_REQUEST_SHARED_VAR(std::string, epgImage, ());   // <%request> std::string epgImage
  _tnt_ignore_unused<epgImage_type>(epgImage);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& pageelems.epg_tool_box ...
  { 
#line 164 "epginfo.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 164 "epginfo.ecpp"
    _tnt_cq9.add( "detail", (detail));
#line 164 "epginfo.ecpp"
    _tnt_cq9.add( "endTime", (epgEvent.GetEndTime()));
#line 164 "epginfo.ecpp"
    _tnt_cq9.add( "epgid", (id));
#line 164 "epginfo.ecpp"
    _tnt_cq9.add( "s_IMDB_ID", (s_IMDB_ID));
#line 164 "epginfo.ecpp"
    _tnt_cq9.add( "startTime", (epgEvent.GetStartTime()));
#line 164 "epginfo.ecpp"
    _tnt_cq9.add( "title", (title));
#line 164 "epginfo.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[21]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
