////////////////////////////////////////////////////////////////////////
// osd.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.osd")

// <%pre>
#line 1 "osd.ecpp"


#include <setup.h>
#include <time.h>
#include <vdr/remote.h>
#include <osd_status.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("osd");

static const char* rawData = "\000\000\000\014\000\000\0002\000\000\0004<\?xml version=\"1.0\" encoding=\"utf-8\"\?> \n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("osd " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 12 "osd.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
  reply.out() << _tntChunks[0]; // <\?xml version="1.0" encoding="utf-8"\?>
  reply.out() << _tntChunks[1]; //  \n
#line 16 "osd.ecpp"

  clock_t lastOsdChange = LiveOsdStatusMonitor().getLastUpdate();
  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl("/login.html?redirect=");
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }
  reply.setContentType("text/plain; charset=utf-8");

  struct timespec ts_req;
  ts_req.tv_sec = 0;
  ts_req.tv_nsec = 1000000;
  for (int i = 0; i < 100 && cRemote::HasKeys() ;++i) nanosleep(&ts_req, nullptr);  // to allow processing the keys before we return

// wait for the OSD being stable (not changing any more)
  for (int i = 0; i < 100; ++i) {
    nanosleep(&ts_req, nullptr);
    clock_t osdChange = LiveOsdStatusMonitor().getLastUpdate();
    if (lastOsdChange == osdChange) break;
    lastOsdChange = osdChange;
  }

  cToSvConcat osd;
  for (int i = 0; i < 100; ++i) {
    osd.clear();
    LiveOsdStatusMonitor().appendHtml(osd);
    clock_t osdChange = LiveOsdStatusMonitor().getLastUpdate();
    if (lastOsdChange == osdChange) break;
    lastOsdChange = osdChange;
  }
  reply.out() << osd;

  // <%/cpp>
  return DEFAULT;
}

} // namespace
