////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <string>
#include <string_view>
#include <setup.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <vdr/channels.h>
#include <stringhelpers.h>
#include <livefeatures.h>

#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class todel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        todel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    todel_type todel;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "\000\000\002\360\000\000\002\361\000\000\002\362\000\000\002\363\000\000\003e\000\000\003"
  "r\000\000\003w\000\000\003|\000\000\003\247\000\000\004\332\000\000\004\342\000\000\004\350\000\000\004\372\000\000"
  "\005B\000\000\005\361\000\000\005\371\000\000\005\377\000\000\006\021\000\000\006\032\000\000\006F\000\000\006\375"
  "\000\000\007,\000\000\007G\000\000\007Y\000\000\010f\000\000\010s\000\000\010\177\000\000\010\222\000\000\t\?\000\000"
  "\t@\000\000\tB\000\000\tC\000\000\tE\000\000\tF\000\000\t\202\000\000\t\225\000\000\t\233\000\000\t\234\000\000\nb"
  "\000\000\n\262\000\000\n\347\000\000\013\032\000\000\013Y\000\000\013\263\000\000\013\275\000\000\013\333\000\000\013"
  "\364\000\000\013\365\000\000\013\366\000\000\013\370\000\000\014R\000\000\014m\000\000\014\272\000\000\014\343\000"
  "\000\015)\000\000\015\177\000\000\015\241\000\000\016\000\000\000\016\027\000\000\016G\000\000\016k\000\000\016t\000"
  "\000\016\250\000\000\016\337\000\000\016\364\000\000\016\377\000\000\017\004\000\000\017\007\000\000\017\013\000\000"
  "\017\030\000\000\0179\000\000\017Q\000\000\017`\000\000\017\203\000\000\017\205\000\000\017\211\000\000\017\217\000"
  "\000\017\243\000\000\017\251\000\000\017\253\000\000\017\257\000\000\017\263\000\000\017\307\000\000\017\310\000\000"
  "\017\311\000\000\017\342\000\000\020\t\000\000\020\021\000\000\020\027\000\000\020\031\000\000\020\033\000\000\020Y"
  "\000\000\020a\000\000\020g\000\000\020i\000\000\020k\000\000\020\273\000\000\020\301\000\000\020\303\000\000\020\305"
  "\000\000\020\312\000\000\021\003\000\000\021\013\000\000\021\021\000\000\021\023\000\000\021\024\000\000\021\031\000"
  "\000\021M\000\000\021|\000\000\021\254\000\000\021\260\000\000\021\274\000\000\021\304\000\000\021\377\000\000\022"
  "\010\000\000\022-\000\000\0226\000\000\0229\000\000\022@\000\000\022A\000\000\022B\000\000\022P\000\000\022Q\000\000"
  "\022R\000\000\022r\000\000\022x\000\000\022\200\000\000\022\206\000\000\022\230\000\000\022\232\000\000\022\245\000"
  "\000\022\264\000\000\022\265\000\000\022\266\000\000\022\331\000\000\022\337\000\000\022\347\000\000\022\355\000\000"
  "\022\377\000\000\023\013\000\000\023\024\000\000\023\033\000\000\023\034\000\000\023\035\000\000\023O\000\000\023f"
  "\000\000\023\213\000\000\023\333\000\000\024F\000\000\024\210\000\000\025\007\000\000\025\031\000\000\025[\000\000"
  "\025\223\000\000\025\226\000\000\025\231\000\000\025\320\000\000\026^\000\000\026\217\000\000\026\317\000\000\026\322"
  "\000\000\027\005\000\000\027\007\000\000\027\010\000\000\027\t\000\000\027\n\000\000\027\013\000\000\027\014\000\000"
  "\027\015\000\000\027\016\000\000\027S\000\000\027\225\000\000\027\230\000\000\027\232\000\000\027\235\000\000\027\241"
  "\000\000\027\245\000\000\027\250\000\000\027\253\000\000\027\270\000\000\027\271\000\000\027\303\000\000\027\322\000"
  "\000\027\326\000\000\027\327\000\000\027\330\000\000\027\331\000\000\027\332\n\n\n\n<html>\n  <head>\n    <meta name="
  "\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n    \n<s"
  "cript>\nconst recordings_tree_creation = ;\nconst recs = [];\nconst rec_ids = Object.create(null)\nrec_ids[\"T\"] = ["
  "1, 2]\n\n// Title is the title of the action (like \"play in media player\"), and will be html encoded here\nfunction"
  " RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href=\"'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s"
  ".a += '&sort=&filter=&flat=&history_num_back=\" title=\"'\n  addEncodeHtml(s, Title)\n  s.a += '\"><img class=\"icon"
  "\" src=\"'\n  s.a += Img\n  s.a += '\" /></a>'\n}\nfunction RecordingActionPlaylist(s, id) {\n  s.a += '<a class=\"hi"
  "dden-xs\" href=\"playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=&filter=&flat=&history_num_back=\" tit"
  "le=\"\" download><img class=\"icon hidden-xs\" src=\"playlist.png\" /></a>'\n}\n\n// do not html encode title! will b"
  "e html encoded here\nfunction addEventRec_r(s, eventid, title, folder, shortText, description) {\n  let http_params ="
  " '&sort=&filter='\n  http_params += encodeURIComponent('')\n  http_params += '&flat=&history_num_back='\n  addEventRe"
  "c(s, 'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</script>\n<script type=\"text/ja"
  "vascript\" src=\"js.html\"></script>\n\n  <script type=\"text/javascript\" src=\"js/live/treeview.js\"></script>\n  <"
  "script>\n  const tv = new Treeview(\"minus.png\", \"plus.png\", \"folder_open.png\", \"folder_closed.png\");\n  </scr"
  "ipt>\n</head>\n<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\" onpageshow=\"clearCheckboxes(document.getE"
  "lementById('form_recordings'))\">\n  \n  \n  \n  <div class=\"inhalt\">\n    <div class=\"boxheader\"><div><div></div"
  "></div></div>\n      \n      <form method=\"post\" name=\"recordings\" id=\"form_recordings\" action=\"recordings.ecp"
  "p\">\n        <div class=\"recordings\">\n          <ul class=\"recordingslist\" style=\"display: block;\">\n        "
  "    \n          </ul>\n        </div>\n        <input type=\"hidden\" name=\"sort\" value=\"\">\n        <input type="
  "\"hidden\" name=\"filter\" value=\"\">\n        <input type=\"hidden\" name=\"flat\" value=\"\">\n        <input type"
  "=\"hidden\" name=\"history_num_back\" value=\"\">\n        <div class=\"withmargin hidden-xs\">\n          <button cl"
  "ass=\"red\" type=\"submit\"></button>\n\n        </div>\n      </form>\n  </div>\n</body>\n</html>\n\n\n\n\n  <li cla"
  "ss=\"recording\">\n    <div class=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n    <table><tr>\n      "
  "        <td class = \"space\">\n          <img src=\"img/transparent.png\" width=\"px\" height=\"16px\" />\n        <"
  "/td>\n            <td class=\"space\">\n        <img class=\"recording_expander\" src=\"plus.png\" />\n      </td><td"
  " class=\"space\">\n        <img class=\"recording_folder\" src=\"folder_closed.png\" />\n      </td>\n        <td cla"
  "ss = space>\n          <div class=\"thumb\">\n            <img data-src=\"/tvscraper/\"\n              class=\"\"\n  "
  "          />\n          </div>\n        </td>\n    <td class=\"recording_folder_name\">\n      \n    </td></tr></tabl"
  "e>\n    </div>\n    <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n      \n    </ul>\n  </li>\n"
  "  <script>\n  recs[]=[]\n  \n</script>\n      <script>\n      rec_ids[\"fldr_\"] = []\n    </script>\n        <script"
  ">\n      document.write(rec_string_d([, , [  ]]))\n      rec_ids[\"fldr_\"] = [, , [  ]]\n      </script>\n    \n\n<s"
  "pan class=\"label bold\"> </span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</sp"
  "an>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html"
  "\?sort=duplicates&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=&filter=&flat"
  "=\" ></a>\n<span class=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" value"
  "=\"\" id=\"filter\" onchange=\"filterRecordings(this, '', '')\" />&nbsp;</span>\n<span class=\"sep\">|</span>\n<img o"
  "nclick=\"ExpandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n\nclass="
  "\"active\"\n\n<a href=\"epginfo.html\?epgid=del_&sort=&filter=&flat=&history_num_back=\" ><img src=\"\" alt=\"\" /></"
  "a>\n\n<a href=\"edit_recording.html\?recid=&sort=&filter=&flat=&history_num_back=\"><img src=\"\" alt=\"\"  /></a>\n"
  "\n<!DOCTYPE html>\n<html>\n  <script>\n    history.go(-);\n  </script>\n</html>\n<div class=\"epg_description\" id=\""
  "del_\">\n  <div class=\"station\">\n    <div class=\"boxheader\"><div><div class=\"caption\"></div></div></div>\n  </"
  "div>\n  <div class=\"epg_content\">\n    <form>\n      <div class=\"about_head\"><div><div></div></div></div>\n      "
  "<input type=\"hidden\" name=\"epgid\" value=\"\" >\n      <input type=\"hidden\" name=\"delete_rec\" value=\"confirme"
  "d\" >\n      <input type=\"hidden\" name=\"history_num_back\" value=\"\" id=\"history_del_\">\n      <div class=\"abo"
  "ut_left\">\n        <button id=\"confirm_del_\" class=\"green\" type=\"button\" onclick=\"delete_rec_back('', )\"></b"
  "utton>\n      </div>\n      <div class=\"about_right\">\n\n<script>\nfunction cancel_delete() {\n  if (document.refer"
  "rer.indexOf(\"epginfo.html\?\") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-);\n  }\n}\n</script>\n   "
  "     <button id=\"close_del_\" type=\"button\" class=\"red\" onclick=\"back_depending_referrer(1, )\"></button>\n    "
  "  </div>\n    </form>\n  </div>\n</div>\n\n\n\n\n\n\n\n\n\n<img data-src=\"img/transparent.png\" height=\"10px\" />\n"
  "<span id=\"icons-\"></span>\n<script class=\"injectIcons\">\ninjectErrorHdSdIcon(\"icons-\", , , \"\", \"\", \"\", , "
  "\"\")\n</script>\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    todel(*this, "todel"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 43 "recordings.ecpp"

std::chrono::time_point<std::chrono::high_resolution_clock> timeStart = std::chrono::high_resolution_clock::now();

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

if (request.getMethod() != "POST") history_num_back = 0;  // we can go back in history to this page
else ++history_num_back;  // we have to go back in history to a prev page, to avoid re-send of form data

// create the "current" values of the global request parameters, based on their old values and the current arguments
// basically, this is a bad idea. Pushing "refresh" changes the sort order :( .
// Better: Urls on menue have parameters depending on the current sort option
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "datedesc" || sort == "dateasc") currentSort = sort;
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "nameasc" || sort == "namedesc") currentSort = sort;
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "errorsts" || sort == "errorsdur") currentSort = sort;
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}

deleteResult = "";
if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
  for (auto it = deletions.begin(); it != deletions.end(); ++it) {
    std::string name;
    if (RecordingsManager::DeleteRecording(*it, &name) == 0) {
      cToSvConcat delRec(tr("Deleted recording:"), " ");
      delRec.appendReplace(name, "~", "/");
      delRec << "<br/>";
      deleteResult += std::string(delRec);
    }
  }
  deletions.clear();
} else {
  throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
}

int FreeMB, UsedMB;
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));


// get data for all open nodes
std::string openTreeNodes;
if (request.hasCookie("VDR-Live-Recordings-Tree-Open-Nodes")) {
  openTreeNodes = request.getCookie("VDR-Live-Recordings-Tree-Open-Nodes");
//  dsyslog("live: VDR-Live-Recordings-Tree-Open-Nodes = %s", openTreeNodes.c_str());
}
cToSvConcat<0> recording_item;
recording_item.reserve(25000);

#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif


  // <& pageelems.doc_type ...
  { 
#line 127 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 127 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 131 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 132 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 132 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 133 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 133 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 134 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 134 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recordings_tree_creation = 
#line 136 "recordings.ecpp"
  reply.sout() << ( cToSvInt(RecordingsManager::GetLastRecordingsUpdate() ) );
  reply.out() << _tntChunks[8]; // ;\nconst recs = [];\nconst rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\n// Title is the title of the action (like "play in media player"), and will be html encoded here\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 147 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[9]; // &filter=
#line 147 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[10]; // &flat=
#line 147 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[11]; // &history_num_back=
#line 147 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[12]; // " title="'\n  addEncodeHtml(s, Title)\n  s.a += '"><img class="icon" src="
#line 149 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[13]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\nfunction RecordingActionPlaylist(s, id) {\n  s.a += '<a class="hidden-xs" href="playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=
#line 156 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[14]; // &filter=
#line 156 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[15]; // &flat=
#line 156 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[16]; // &history_num_back=
#line 156 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[17]; // " title="
#line 156 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[18]; // " download><img class="icon hidden-xs" src="
#line 156 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[19]; // playlist.png" /></a>'\n}\n\n// do not html encode title! will be html encoded here\nfunction addEventRec_r(s, eventid, title, folder, shortText, description) {\n  let http_params = '&sort=
#line 161 "recordings.ecpp"
  reply.sout() << ( sort );
  reply.out() << _tntChunks[20]; // &filter='\n  http_params += encodeURIComponent('
#line 162 "recordings.ecpp"
  reply.sout() << ( filter );
  reply.out() << _tntChunks[21]; // ')\n  http_params += '&flat=
#line 163 "recordings.ecpp"
  reply.sout() << ( flat );
  reply.out() << _tntChunks[22]; // &history_num_back=
#line 163 "recordings.ecpp"
  reply.sout() << ( history_num_back+1 );
  reply.out() << _tntChunks[23]; // '\n  addEventRec(s, 'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</script>\n<script type="text/javascript" src="js.html"></script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 171 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[24]; // minus.png", "
#line 171 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[25]; // plus.png", "
#line 171 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[26]; // folder_open.png", "
#line 171 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[27]; // folder_closed.png");\n  </script>\n</head>\n<body onload="adjustHeader()" onresize="adjustHeader()" onpageshow="clearCheckboxes(document.getElementById('form_recordings'))">\n  
  // <& pageelems.logo ...
  { 
#line 175 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 175 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[28]; // \n
#line 176 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[29]; //   
  // <& menu ...
  { 
#line 183 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 183 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 183 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 183 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 183 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n
#line 184 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[31]; //   
  // <& menu ...
  { 
#line 187 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 187 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 187 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 187 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 187 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[32]; // \n
#line 188 "recordings.ecpp"

}

  reply.out() << _tntChunks[33]; //   <div class="inhalt">\n    <div class="boxheader"><div><div>
#line 192 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[34]; // </div></div></div>\n
#line 193 "recordings.ecpp"

    int rec_cnt;
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[35]; //       
#line 201 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[36]; // \n
#line 202 "recordings.ecpp"

    } else {
// get and set sort order
// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
      bool reverse = false;
      RecordingsManager::eSortOrder sortOrder = RecordingsManager::eSortOrder::name; // default
      if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = RecordingsManager::eSortOrder::date;
      if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = RecordingsManager::eSortOrder::errors;
      if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = RecordingsManager::eSortOrder::durationDeviation;
      if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = RecordingsManager::eSortOrder::duplicatesLanguage;
      if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
      RecordingsManager::setSortOrder(sortOrder, reverse, currentFilter);  // this also updates the recurdings, if required

// get root directory
      RecordingsItemDirPtr recItemRoot;
      if (currentSort.compare(0, 10, "duplicates", 10) == 0) {
        DuplicatesRecordingsTreePtr duplicatesRecordingsTree(RecordingsManager::GetDuplicatesRecordingsTree());
        if (currentFlat == "true")
          recItemRoot = duplicatesRecordingsTree->getFlatRoot();
        else
          recItemRoot = duplicatesRecordingsTree->getRoot();
      } else {
        if (currentFlat == "true")
          recItemRoot = std::make_shared<RecordingsItemDirFlat>();
        else
          recItemRoot = RecordingsManager::GetRecordingsTree()->getRoot();
      }

      uintptr_t irecording_item = (uintptr_t)&recording_item;
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;
      uintptr_t iOpenTreeNodes = (uintptr_t)&openTreeNodes;

  reply.out() << _tntChunks[37]; //       <form method="post" name="recordings" id="form_recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: block;">\n            
  // <& recordings.recordings_item ...
  { 
#line 238 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 238 "recordings.ecpp"
    _tnt_cq7.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 238 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 238 "recordings.ecpp"
    _tnt_cq7.add( "irecording_item", (irecording_item));
#line 238 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[38]; // \n          </ul>\n        </div>\n        <input type="hidden" name="sort" value="
#line 241 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[39]; // ">\n        <input type="hidden" name="filter" value="
#line 242 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[40]; // ">\n        <input type="hidden" name="flat" value="
#line 243 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[41]; // ">\n        <input type="hidden" name="history_num_back" value="
#line 244 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[42]; // ">\n        <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 246 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[43]; // </button>\n
  reply.out() << _tntChunks[44]; // \n        </div>\n      </form>\n
#line 250 "recordings.ecpp"

    }
std::chrono::duration<double> timeNeeded = std::chrono::high_resolution_clock::now() - timeStart;
dsyslog("live, time recordings.ecpp: %f", timeNeeded.count());

  reply.out() << _tntChunks[45]; //   </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[46]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[47]; // \n
  reply.out() << _tntChunks[48]; // \n\n
  reply.out() << _tntChunks[82]; // \n
  reply.out() << _tntChunks[83]; // \n
  reply.out() << _tntChunks[118]; // \n
  reply.out() << _tntChunks[119]; // \n
  reply.out() << _tntChunks[121]; // \n
  reply.out() << _tntChunks[122]; // \n
  reply.out() << _tntChunks[131]; // \n
  reply.out() << _tntChunks[132]; // \n
  reply.out() << _tntChunks[141]; // \n
  reply.out() << _tntChunks[142]; // \n
  reply.out() << _tntChunks[161]; // \n\n
  reply.out() << _tntChunks[162]; // \n
  reply.out() << _tntChunks[179]; // \n
  reply.out() << _tntChunks[184]; // \n
  reply.out() << _tntChunks[185]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecording_item = qparam.get< uintptr_t >("irecording_item", ( 0));
uintptr_t iOpenTreeNodes = qparam.get< uintptr_t >("iOpenTreeNodes", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 269 "recordings.ecpp"

// get rec item of this (current) dir
RecordingsItemDirPtr recItemThisDir = *(static_cast<RecordingsItemDirPtr *>((void *)iRecItem) );
cToSvConcat<0> *recording_item = static_cast<cToSvConcat<0> *>((void *)irecording_item );
std::string openTreeNodes= *(static_cast<std::string *>((void *)iOpenTreeNodes) );
int level = recItemThisDir->Level();

// data for dirs, and prepare loop over dirs
const_rec_iterator<RecordingsItemDirPtr> l_dir_iterator = recItemThisDir->get_dir_iterator();
if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") l_dir_iterator.set_backwards(true);

for (const RecordingsItemDirPtr &recItem: l_dir_iterator) {
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>

// search trough directory for new recordings
  bool newR = false;
  if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
  cToSvXxHash32 idHash(cToSvConcat(parentIdHash, recItem->Name()));
  iRecItem = (uintptr_t)&recItem;

  reply.out() << _tntChunks[49]; //   <li class="recording">\n    <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 293 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[50]; // ')">\n    <table><tr>\n      
#line 295 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[51]; //         <td class = "space">\n          <img src="img/transparent.png" width="
#line 297 "recordings.ecpp"
  reply.sout() << ( 16*level );
  reply.out() << _tntChunks[52]; // px" height="16px" />\n        </td>\n      
#line 299 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[53]; //       <td class="space">\n        <img class="recording_expander" src="
#line 301 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[54]; // plus.png" />\n      </td><td class="space">\n        <img class="recording_folder" src="
#line 303 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[55]; // folder_closed.png" />\n      </td>\n
#line 305 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[56]; //         <td class = space>\n          <div class="thumb">\n            <img data-src="/tvscraper/
#line 308 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[57]; // "\n              class="
#line 309 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[58]; // "\n            />\n          </div>\n        </td>\n
#line 313 "recordings.ecpp"
         }

  reply.out() << _tntChunks[59]; //     <td class="recording_folder_name
#line 314 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[60]; // ">\n      
#line 315 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[61]; // \n    </td></tr></table>\n    </div>\n    <ul id="fldr_
#line 318 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[62]; // " class="recordingslist" style="display: none;">\n      
  // <& recordings.recordings_item ...
  { 
#line 319 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 319 "recordings.ecpp"
    _tnt_cq8.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 319 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 319 "recordings.ecpp"
    _tnt_cq8.add( "irecording_item", (irecording_item));
#line 319 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 319 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[63]; // \n    </ul>\n  </li>\n  
#line 322 "recordings.ecpp"

} // end of loop over subdirs
// now the items

const_rec_iterator<RecordingsItemRec*> l_rec_iterator = recItemThisDir->get_rec_iterator();

// do we have to get/write the recording details?
// we have to, if currentFlat == true || level == 0 || this folder is open (cookie)
bool write_recs = level == 0;
if (!write_recs) {
// check: is this folder open (cookie)?
  auto equal_fldf = [parentIdHash](cSv f) { return f.length() > 5 && f.compare(5, std::string_view::npos, parentIdHash) == 0; };
  cSplit splitOpenTreeNodes(openTreeNodes, ',', eSplitDelimBeginEnd::optional);
  write_recs = std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end();
}
if (write_recs) {
  
  reply.out() << _tntChunks[64]; // <script>\n  
#line 340 "recordings.ecpp"

  std::chrono::time_point<std::chrono::high_resolution_clock> timeStart_recs = std::chrono::high_resolution_clock::now();
  for (const RecordingsItemRec *rPtr: l_rec_iterator)
  {
    recording_item->clear();
    rPtr->AppendAsJSArray(*recording_item);
  
  reply.out() << _tntChunks[65]; // recs[
#line 347 "recordings.ecpp"
  reply.out() << (cToSvInt(rPtr->Id()));
  reply.out() << _tntChunks[66]; // ]=[
#line 347 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[67]; // ]\n  
#line 348 "recordings.ecpp"

  }
  std::chrono::duration<double> timeNeeded_recs = std::chrono::high_resolution_clock::now() - timeStart_recs;
//  dsyslog("live, time recordings.ecpp recs lv 0: %f", timeNeeded_recs.count());
  l_rec_iterator.set_begin();
  
  reply.out() << _tntChunks[68]; // \n</script>\n  
#line 356 "recordings.ecpp"

}
  if (l_rec_iterator == iterator_end() )
  { 
  reply.out() << _tntChunks[69]; //     <script>\n      rec_ids["fldr_
#line 361 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[70]; // "] = []\n    </script>\n  
#line 363 "recordings.ecpp"
 } else {
    bool first = true;
    const char *displayFolder = "1";
    recording_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recording_item, l_rec_iterator, first);
    
  reply.out() << _tntChunks[71]; //       <script>\n
#line 370 "recordings.ecpp"
   if (level == 0) {

  reply.out() << _tntChunks[72]; //       document.write(rec_string_d([
#line 371 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[73]; // , 
#line 371 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[74]; // , [ 
#line 371 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[75]; //  ]]))\n
#line 372 "recordings.ecpp"
   } else {

  reply.out() << _tntChunks[76]; //       rec_ids["fldr_
#line 373 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[77]; // "] = [
#line 373 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[78]; // , 
#line 373 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[79]; // , [ 
#line 373 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[80]; //  ]]\n
#line 374 "recordings.ecpp"
   }

  reply.out() << _tntChunks[81]; //       </script>\n    
#line 376 "recordings.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 383 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[84]; // <span class="label bold">
#line 384 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[85]; //  </span>\n<a href="recordings.html\?sort=
#line 385 "recordings.ecpp"
  reply.sout() << ( (currentSort == "nameasc") ? "namedesc" : "nameasc");
  reply.out() << _tntChunks[86]; // &filter=
#line 385 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[87]; // &flat=
#line 385 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[88]; // " 
  // <& setactive ...
  { 
#line 385 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 385 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 385 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[89]; //  >
#line 385 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[90]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 387 "recordings.ecpp"
  reply.sout() << ( (currentSort == "datedesc") ? "dateasc" : "datedesc");
  reply.out() << _tntChunks[91]; // &filter=
#line 387 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[92]; // &flat=
#line 387 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[93]; // " 
  // <& setactive ...
  { 
#line 387 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 387 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 387 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[94]; //  >
#line 387 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[95]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 389 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[96]; // &flat=
#line 389 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[97]; // " 
  // <& setactive ...
  { 
#line 389 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 389 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 389 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[98]; //  >
#line 389 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[99]; // </a>\n
#line 390 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[100]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 394 "recordings.ecpp"
  reply.sout() << ( (currentSort == "errorsts") ? "errorsdur" : "errorsts" );
  reply.out() << _tntChunks[101]; // &filter=
#line 394 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[102]; // &flat=
#line 394 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[103]; // " 
  // <& setactive ...
  { 
#line 394 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 394 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 394 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[104]; // >
#line 394 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[105]; // </a>\n
#line 395 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[106]; // <span class="sep">|</span>\n<span class="label bold">
#line 399 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[107]; // :&nbsp;<input type="text" name="filter" value="
#line 399 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[108]; // " id="filter" onchange="filterRecordings(this, '
#line 399 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[109]; // ', '
#line 399 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[110]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 399 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 399 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 399 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[111]; // </span>\n
#line 400 "recordings.ecpp"

if (currentFlat != "true") {

  reply.out() << _tntChunks[112]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 404 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[113]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 404 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 404 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Expand all folders")));
#line 404 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[114]; // />\n<img onclick="CollapseAll()" src="
#line 405 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[115]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 405 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 405 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Collapse all folders")));
#line 405 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[116]; // />\n
#line 406 "recordings.ecpp"

}

  reply.out() << _tntChunks[117]; // <br />\n
#line 410 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 418 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[120]; // class="active"
#line 419 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 431 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[123]; // <a href="epginfo.html\?epgid=del_
#line 431 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[124]; // &sort=
#line 431 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[125]; // &filter=
#line 431 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[126]; // &flat=
#line 431 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[127]; // &history_num_back=
#line 431 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[128]; // " 
  // <& tooltip.hint ...
  { 
#line 431 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 431 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Delete this recording from hard disc!")));
#line 431 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[129]; // ><img src="
#line 431 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[130]; // " alt="" /></a>
#line 431 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 443 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[133]; // <a href="edit_recording.html\?recid=
#line 443 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[134]; // &sort=
#line 443 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[135]; // &filter=
#line 443 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[136]; // &flat=
#line 443 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[137]; // &history_num_back=
#line 443 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[138]; // "><img src="
#line 443 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[139]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 443 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 443 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Edit recording")));
#line 443 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[140]; //  /></a>
#line 443 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::todel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::todel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string todel = qparam.get< std::string >("todel");
std::string confirmed = qparam.get< std::string >("confirmed");
std::string history_num_back = qparam.get< std::string >("history_num_back");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 453 "recordings.ecpp"

  std::string recording_Name;
  {
    LOCK_RECORDINGS_READ;
    const cRecording *recording = RecordingsManager::GetByHash(todel, Recordings);
    if (recording == nullptr)
      throw HtmlError(tr("Couldn't find recording or no recordings available"));
    recording_Name = recording->Name();
  }
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  if (confirmed == "confirmed") {
    RecordingsManager::DeleteRecording(todel);

  reply.out() << _tntChunks[143]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-
#line 470 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[144]; // );\n  </script>\n</html>\n
#line 473 "recordings.ecpp"
  } else {

  reply.out() << _tntChunks[145]; // <div class="epg_description" id="del_
#line 474 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[146]; // ">\n  <div class="station">\n    <div class="boxheader"><div><div class="caption">
#line 476 "recordings.ecpp"
  reply.sout() << ( tr("Delete recordings") );
  reply.out() << _tntChunks[147]; // </div></div></div>\n  </div>\n  <div class="epg_content">\n    <form>\n      <div class="about_head"><div><div>
#line 480 "recordings.ecpp"
  reply.sout() << ( cToSvFormated(tr("Delete recording \"%s\"?"), recording_Name.empty()?"No recording name available":recording_Name.c_str() ) );
  reply.out() << _tntChunks[148]; // </div></div></div>\n      <input type="hidden" name="epgid" value="
#line 481 "recordings.ecpp"
  reply.sout() << (todel);
  reply.out() << _tntChunks[149]; // " >\n      <input type="hidden" name="delete_rec" value="confirmed" >\n      <input type="hidden" name="history_num_back" value="
#line 483 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[150]; // " id="history_del_
#line 483 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[151]; // ">\n      <div class="about_left">\n        <button id="confirm_del_
#line 485 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[152]; // " class="green" type="button" onclick="delete_rec_back('
#line 485 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[153]; // ', 
#line 485 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[154]; // )">
#line 485 "recordings.ecpp"
  reply.sout() << ( tr("Delete"));
  reply.out() << _tntChunks[155]; // </button>\n      </div>\n      <div class="about_right">\n
  reply.out() << _tntChunks[156]; // \n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf("epginfo.html\?") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-
#line 494 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[157]; // );\n  }\n}\n</script>\n        <button id="close_del_
#line 498 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[158]; // " type="button" class="red" onclick="back_depending_referrer(1, 
#line 498 "recordings.ecpp"
  reply.sout() << (history_num_back );
  reply.out() << _tntChunks[159]; // )">
#line 498 "recordings.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[160]; // </button>\n      </div>\n    </form>\n  </div>\n</div>\n
#line 503 "recordings.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 518 "recordings.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 519 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 519 "recordings.ecpp"
    _tnt_cq18.add( "action", "play_recording");
#line 519 "recordings.ecpp"
    _tnt_cq18.add( "alt", "");
#line 519 "recordings.ecpp"
    _tnt_cq18.add( "image", "play.png");
#line 519 "recordings.ecpp"
    _tnt_cq18.add( "param", (id));
#line 519 "recordings.ecpp"
    _tnt_cq18.add( "tip", (tr("play this recording")));
#line 519 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[163]; // \n
#line 520 "recordings.ecpp"
   }

  // <& pageelems.hls_recording ...
  { 
#line 521 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 521 "recordings.ecpp"
    _tnt_cq19.add( "recId", (id));
#line 521 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_recording"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[164]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 522 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 522 "recordings.ecpp"
    _tnt_cq20.add( "recid", (id));
#line 522 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[165]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 523 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 523 "recordings.ecpp"
    _tnt_cq21.add( "s_IMDB_ID", (s_IMDB_ID));
#line 523 "recordings.ecpp"
    _tnt_cq21.add( "title", (title));
#line 523 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[166]; // \n
  // <& recordings.edit_rec ...
  { 
#line 524 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 524 "recordings.ecpp"
    _tnt_cq22.add( "filter", (filter));
#line 524 "recordings.ecpp"
    _tnt_cq22.add( "flat", (flat));
#line 524 "recordings.ecpp"
    _tnt_cq22.add( "history_num_back", (history_num_back));
#line 524 "recordings.ecpp"
    _tnt_cq22.add( "id", (id));
#line 524 "recordings.ecpp"
    _tnt_cq22.add( "sort", (sort));
#line 524 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[167]; // \n
  // <& recordings.del_rec ...
  { 
#line 525 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 525 "recordings.ecpp"
    _tnt_cq23.add( "filter", (filter));
#line 525 "recordings.ecpp"
    _tnt_cq23.add( "flat", (flat));
#line 525 "recordings.ecpp"
    _tnt_cq23.add( "history_num_back", (history_num_back));
#line 525 "recordings.ecpp"
    _tnt_cq23.add( "id", (id));
#line 525 "recordings.ecpp"
    _tnt_cq23.add( "sort", (sort));
#line 525 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[168]; // \n
#line 526 "recordings.ecpp"

const RecordingsItemRec* recPtr = RecordingsManager::GetByIdHash(id);
if (recPtr) {
  const char *sdhd = nullptr;
  cToSvConcat frameParams;
  StringAppendFrameParams(frameParams, recPtr);
  switch (recPtr->FrameWidth()) {
    case 720:
      sdhd = "720x576";
      break;
    case 1280:
      sdhd = "1280x720";
      break;
    case 1920:
      sdhd = "1920x1080";
      break;
    case 3840:
      sdhd = "3840x2160";
      break;
    default:
      break;
  }
  int video_SD_HD = recPtr->SD_HD();
  if (!sdhd) sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": "ud";
  cToSvConcat duration;
  AppendDuration(duration, tr("%d:%02d"), recPtr->Duration() );

  reply.out() << _tntChunks[169]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 554 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[170]; // "></span>\n<script class="injectIcons">\ninjectErrorHdSdIcon("icons-
#line 556 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[171]; // ", 
#line 556 "recordings.ecpp"
  reply.sout() << (cToSvInt(recPtr->RecordingErrors()));
  reply.out() << _tntChunks[172]; // , 
#line 556 "recordings.ecpp"
  reply.sout() << (cToSvInt(recPtr->DurationDeviation()));
  reply.out() << _tntChunks[173]; // , "
#line 556 "recordings.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[174]; // ", "
#line 556 "recordings.ecpp"
  reply.sout() << (recPtr->ChannelName());
  reply.out() << _tntChunks[175]; // ", "
#line 556 "recordings.ecpp"
  reply.sout() << (duration);
  reply.out() << _tntChunks[176]; // ", 
#line 556 "recordings.ecpp"
  reply.sout() << ( cToSvInt(recPtr->NumberTsFiles()) );
  reply.out() << _tntChunks[177]; // , "
#line 556 "recordings.ecpp"
  reply.sout() << (frameParams);
  reply.out() << _tntChunks[178]; // ")\n</script>\n
#line 558 "recordings.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[180]; // <img src="
#line 569 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[181]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 569 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 569 "recordings.ecpp"
    _tnt_cq24.add( "text", (archived));
#line 569 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[182]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 570 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 570 "recordings.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 570 "recordings.ecpp"
    _tnt_cq25.add( "title", (title));
#line 570 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[183]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 575 "recordings.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 575 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[186]; // \n
#line 576 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
