////////////////////////////////////////////////////////////////////////
// users.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.users")

// <%pre>
#line 1 "users.ecpp"


#include <users.h>
#include <setup.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class user_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        user_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    user_actions_type user_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("users");

static const char* rawData = "\000\000\000d\000\000\000\326\000\000\000\343\000\000\000\350\000\000\0012\000\000\0017"
  "\000\000\001\361\000\000\002}\000\000\002\304\000\000\003\015\000\000\003'\000\000\003J\000\000\003k\000\000\003w\000"
  "\000\003\200\000\000\003\264\000\000\003\321\000\000\003\353\000\000\003\364\000\000\004\021\000\000\004=\000\000\004"
  ">\000\000\004\?\000\000\004X\000\000\004]\n<html>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width"
  ", initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n  </head>\n  <body onload=\"adjustHeader()\" onre"
  "size=\"adjustHeader()\">\n    \n    \n    <div class=\"inhalt\">\n      <table class=\"listing\" cellspacing=\"0\" ce"
  "llpadding=\"0\">\n        <tr class=\"head\">\n          <td colspan=\"3\">\n            <div class=\"boxheader\"><di"
  "v><div></div></div></div>\n          </td>\n        </tr>\n        <tr class=\"description\">\n          <td class=\""
  "action leftcol\"><div class=\"leftcol\"></div></td>\n          <td class=\"rightcol\" colspan=\"8\"/>\n        </tr>"
  "\n          <tr class=\"description\">\n            <td class=\"action leftcol \"><div class=\"withmargin\"></div></t"
  "d>\n            <td class=\"\"><a href=\"edit_user.html\?userid=\"><img src=\"\" alt=\"\"  /></a></td>\n            <"
  "td class=\"action rightcol \"><a href=\"users.html\?userid=&action=delete\"><img src=\"\" alt=\"\"  /></a></td>\n    "
  "      </tr>\n      </table>\n    </div>\n  </body>\n</html>\n\n\n<a href=\"edit_user.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    user_actions(*this, "user_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("users " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string userid = qparam.get< std::string >("userid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 15 "users.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 18 "users.ecpp"

if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

#line 25 "users.ecpp"

  pageTitle = tr("Users");
  if ( !userid.empty() ) {
    if (action == "delete")
    {
      Users.Del(Users.GetByUserId( userid ));
      Users.Save();
    }
  }

  // <& pageelems.doc_type ...
  { 
#line 35 "users.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 35 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 39 "users.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 40 "users.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 40 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 41 "users.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 41 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n  </head>\n  <body onload="adjustHeader()" onresize="adjustHeader()">\n    
  // <& pageelems.logo ...
  { 
#line 44 "users.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 44 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& menu ...
  { 
#line 45 "users.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 45 "users.ecpp"
    _tnt_cq4.add( "active", ("users"));
#line 45 "users.ecpp"
    _tnt_cq4.add( "component", ("users.user_actions"));
#line 45 "users.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    <div class="inhalt">\n      <table class="listing" cellspacing="0" cellpadding="0">\n        <tr class="head">\n          <td colspan="3">\n            <div class="boxheader"><div><div>
#line 50 "users.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[6]; // </div></div></div>\n          </td>\n        </tr>\n        <tr class="description">\n          <td class="action leftcol"><div class="leftcol">
#line 54 "users.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[7]; // </div></td>\n          <td class="rightcol" colspan="8"/>\n        </tr>\n
#line 57 "users.ecpp"

        cUser* user = Users.First();
        while (user)
        {
          bool bottom = (Users.Next(user) == NULL);
            if (user)
            {

  reply.out() << _tntChunks[8]; //           <tr class="description">\n            <td class="action leftcol 
#line 66 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[9]; // "><div class="withmargin">
#line 66 "users.ecpp"
  reply.sout() << ( user->Name() );
  reply.out() << _tntChunks[10]; // </div></td>\n            <td class="
#line 67 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[11]; // "><a href="edit_user.html\?userid=
#line 67 "users.ecpp"
  reply.sout() << ( user->Id() );
  reply.out() << _tntChunks[12]; // "><img src="
#line 67 "users.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[13]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 67 "users.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 67 "users.ecpp"
    _tnt_cq5.add( "text", (tr("Edit user")));
#line 67 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[14]; //  /></a></td>\n            <td class="action rightcol 
#line 68 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[15]; // "><a href="users.html\?userid=
#line 68 "users.ecpp"
  reply.sout() << ( user->Id() );
  reply.out() << _tntChunks[16]; // &action=delete"><img src="
#line 68 "users.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[17]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 68 "users.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 68 "users.ecpp"
    _tnt_cq6.add( "text", (tr("Delete user")));
#line 68 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[18]; //  /></a></td>\n          </tr>\n
#line 70 "users.ecpp"

            }
            user = Users.Next(user);
        }

  reply.out() << _tntChunks[19]; //       </table>\n    </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[20]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[21]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::user_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("users::user_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 15 "users.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[22]; // <a href="edit_user.html">
#line 82 "users.ecpp"
  reply.sout() << ( tr("New user") );
  reply.out() << _tntChunks[23]; // </a>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
